#!/bin/bash
#first argument: input file; second argument: reduction in resolution (starting at 500 m, 20 gives 10 km)
wf=$1
wd=$3
from=$4
to=$5 # where to put the results?

resolfac=$2
let resolution=${resolfac}/2
#
#projparamfile=projier10km.prm
wfout=$1

date
#apply mask
$wd'mask_sds' -sds=sur_refl_b01,sur_refl_b02,sur_refl_b03,sur_refl_b06, -fill=-28672 -mask=${from}$wf,sur_refl_qc_500m,0-1==00,AND,*,sur_refl_state_500m,15==0 -of=${to}qual.hdf ${from}$wf
date

#try intermediate calculation using hdf, use math_sds and other LDOPE tools
#first EVI and LSWI, then aggregate to 2x2

#EVI
#problem: minus sign; need to recompile LDOPE math_sds; also include 2 scalars to allow linear combination (a*SDS1 + b*SDS2 + c)
#Net/Groups/BSY_3/cgerbig/MODIS/MODAT/bin/math_sds -of=evi1.hdf -math=sur_refl_b02,qual.hdf,-,sur_refl_b01,qual.hdf,INT16,-28672,-28672,-28672,-28672,a,b,c,sds_name_out
#EVI = 2.5 * (b2 - b1) / (b2 + 6*b1 - 7.5*b3 + 10000) # here L is 10000 since data has a scaling factor to save memory
#b2 - b1
$wd'math_sds' -of=${to}evi1.hdf -math=sur_refl_b02,${to}qual.hdf,-,sur_refl_b01,${to}qual.hdf,INT16,-28672,-28672,-28672,-28672,1,1,0,*
#b2 + 6*b1
$wd'math_sds' -of=${to}evi2.hdf -math=sur_refl_b02,${to}qual.hdf,+,sur_refl_b01,${to}qual.hdf,INT16,-28672,-28672,-28672,-28672,1,6,0,*
#b2 + 6*b1 - 7.5*b3 + 10000
$wd'math_sds' -of=${to}evi3.hdf -math=sur_refl_b02,${to}evi2.hdf,-,sur_refl_b03,${to}qual.hdf,INT16,-28672,-28672,-28672,-28672,1,7.5,10000,*
#EVI = 2.5 * (b2 - b1) / (b2 + 6*b1 - 7.5*b3 + 10000)
$wd'math_sds' -of=${to}evi4.hdf -math=sur_refl_b02,${to}evi1.hdf,/,sur_refl_b02,${to}evi3.hdf,INT16,-28672,-28672,-28672,-28672,2.5,1,0,evi

#aggregate from 500m to 2 km by simple averaging, keep meta data
#USE 5 KM to not lose information when reprojecting to Lambert
$wd'reduce_sds' -of=${to}evi5.hdf -rf=$resolfac -avg -sds=evi -meta ${to}evi4.hdf
#after calculating, copy projection parameter metadata
$wd'cp_proj_param' -ref=${from}$wf -of=${to}'evi_'${resolution}'km_'$wf ${to}evi5.hdf

#make sure negative values are masked out NOT REQUIRED
#need to use <max to set negative values to missing; max=32767 for INT16
#mask_sds -sds=evi -fill=-28672 -mask='evi_MOD09A1.A2005153.h17v04.004.2005166213054.hdf,evi,<32767' -of=msk_evi_MOD09A1.A2005153.h17v04.004.2005166213054.hdf evi_MOD09A1.A2005153.h17v04.004.2005166213054.hdf


#reproject to Lambert conical conformal projection NO, FIRST AGGREGATE TILES
rm ${to}evi1.hdf
rm ${to}evi2.hdf
rm ${to}evi3.hdf
rm ${to}evi4.hdf
rm ${to}evi5.hdf
rm ${to}qual.hdf
echo EVI done for $wf!

date

#create_sds_ts_stats param= #for timeseries of fields, get min, or max, or mean etc as a 2D field
