#grid definitions for Europe, 10 km
sourcepath<-"/Net/Groups/BSY/BSY_3/cgerbig/GRIDCODEcvs/stiltR/"
source("/Net/Groups/BSY/BSY_3/cgerbig/GRIDCODEcvs/stiltR/sourceall.r")
#compare with us grid:
dim(getr("veg.19.001","/Net/Groups/BSY/BSY_3/cgerbig/RData/Vegetation/"))

#want tower in center of domain
Alterra.x<-0.196; Alterra.y<-44.464

ll.x<--12
ll.y<-35
numpix.x<-376
numpix.y<-324
xres<-1/4*1/2
yres<-1/6*1/2

#check distances
source("/Net/Groups/BSY/BSY_3/cgerbig/Rsource/polarR/distance.r")
latsfin1<-((1:numpix.y)*yres+ll.y)%o%rep(1,numpix.x);lonsfin1<-rep(1,numpix.y)%o%((1:numpix.x)*xres+ll.x)
latsfin2<-((1:numpix.y)*yres+ll.y+yres)%o%rep(1,numpix.x);lonsfin2<-rep(1,numpix.y)%o%((1:numpix.x)*xres+ll.x+xres)
dxll<-distance(lonsfin1,lonsfin2,(latsfin1+latsfin2)/2,(latsfin1+latsfin2)/2)
dyll<-distance((lonsfin1+lonsfin2)/2,(lonsfin1+lonsfin2)/2,latsfin1,latsfin2)
areall.mat<-dxll*dyll #area in km^2, for lat-lon grid, in lat-lon grid.

#plot domain
imagell(dxll, lg = F, zlims = NULL, zoom = NULL, center = c(Alterra.x,Alterra.y),
    rays = F, lon.ll = ll.x, lat.ll = ll.y, lon.res = 1/4*1/2, 
    lat.res = 1/6*1/2, nlevel = 64, col = topo.colors(64), citiesTF = F, 
    part = NULL, dev = "X11", type = "")

#get vegetation grid from synmap
if(FALSE){ #takes about 10 minutes
source("/Net/Groups/BSY/BSY_3/cgerbig/Rsource/Vegetation/ReadSynmapDMM.r")
synmap.europe<-ReadSynmap(infile="/Net/Groups/BSY/BSY_3/cgerbig/RData/Vegetation/synmap/synmap_LC_jan1",
                         subLon=c(ll.x,numpix.x*xres+ll.x),subLat=c(numpix.y*yres+ll.y,ll.y))
assignr("synmap.europe",synmap.europe,"/Net/Groups/BSY/BSY_3/cgerbig/RData/Vegetation/Europe/")
synmap.europe<-getr("synmap.europe","/Net/Groups/BSY/BSY_3/cgerbig/RData/Vegetation/Europe/")
synmap10<-SortandFracSynmap(synmap.europe,ll.x,ll.y,numpix.x,numpix.y,xres,yres,nclss=48,reclssH2O=FALSE)
#synmap10<-SortandFracSynmap(synmap.europe,ll.x,ll.y,numpix.x,numpix.y,xres,yres,nclss=48,reclssH2O=TRUE) #takes about 1 week
assignr("synmap10",synmap10,"/Net/Groups/BSY/BSY_3/cgerbig/RData/Vegetation/Europe/")
#this has water in first layer, not in last as igbp!!! fix below
synmap10<-getr("synmap10","/Net/Groups/BSY/BSY_3/cgerbig/RData/Vegetation/Europe/")
imagell(synmap10[,,1],lg=F,zlims=NULL,zoom=NULL,center=c(0,45),rays=F,lon.ll=ll.x,lat.ll=ll.y,lon.res=1/4*1/2,lat.res=1/6*1/2,nlevel=64,col=topo.colors(64),citiesTF=F,part=NULL, dev = "X11",type="")
synmap.europe.10km<-synmap10
synmap.europe.10km[,,1:47]<-synmap10[,,2:48]
synmap.europe.10km[,,48]<-synmap10[,,1]
assignr("synmap.europe.10km",synmap.europe.10km,"/Net/Groups/BSY/BSY_3/cgerbig/RData/Vegetation/Europe/")
source("gen_veg_mat_SynMap.r")#make into dynamic grid resolution objects, all 48 classes
source("/Net/Groups/BSY/BSY_3/cgerbig/Rsource/Vegetation/gen_veg_mat_SynMap_VPRM.r")#make into dynamic grid resolution objects, mapped to 8 VPRM classes
}

#vegetation grid from ECOCLIMAP SW: in MODIS/MODextract/getfluxtiles.r, 
#eco2vprm<-getr("vegmap.ecoc2vprm",datp) #datp="/Net/Groups/BSY/BSY_3/cgerbig/RData/CarboEurope/"


#get emission grid from IER
#
source("read_IER_Stuttgart_emissionsV2.r")
get.ierdata(loc="SF",month=5,sday=21,spec="CO2",outpath="/Net/Groups/BSY/BSY_3/cgerbig/RData/ROAM/Fluxes/Emission/",
                      ll.x=-12,ll.y=35,numpix.x=376,numpix.y=324,xres=1/4*1/2,yres=1/6*1/2)

source("read_IER_Stuttgart_emissionsV2.r")
get.ierdata(loc="SF",month=5,sday=19,spec="CO",outpath="/Net/Groups/BSY/BSY_3/cgerbig/RData/ROAM/Fluxes/Emission/",
                      ll.x=-12,ll.y=35,numpix.x=376,numpix.y=324,xres=1/4*1/2,yres=1/6*1/2)
test<-getr("CO2.SF.5.19.2000","/Net/Groups/BSY/BSY_3/cgerbig/RData/ROAM/Fluxes/Emission/")

source("read_IER_Stuttgart_emissionsV2.r")
get.ierdata(loc="EU",month=5,sday=1,spec="CO2",outpath="/Net/Groups/BSY/BSY_3/cgerbig/RData/ROAM/Fluxes/Emission/",
                      ll.x=-12,ll.y=35,numpix.x=376,numpix.y=324,xres=1/4*1/2,yres=1/6*1/2)
test<-getr("CO2.EU.5.1.2000","/Net/Groups/BSY/BSY_3/cgerbig/RData/ROAM/Fluxes/Emission/")

source("/Net/Groups/BSY/BSY_3/cgerbig/Rsource/Vegetation/read_IER_Stuttgart_emissionsEUV2.r")
get.ierdata(loc="EU10",month=5,days=21:31,spec="CO2",outpath="/Net/Groups/BSY/BSY_3/cgerbig/RData/ROAM/Fluxes/Emission/",
                      ll.x=-12,ll.y=35,numpix.x=376,numpix.y=324,xres=1/4*1/2,yres=1/6*1/2)

#nice R CMD BATCH /Net/Groups/BSY/BSY_3/cgerbig/Rsource/Vegetation/get.ierdataEU10.r /Net/Groups/BSY/BSY_3/cgerbig/Rsource/Vegetation/get.ierdataEU10.log &

#add EDGAR where missing
