#replace NA's with neighbours in space and time
#also includes diagonal neighbours
na.replace<-function(dat,diagTF=FALSE){
  nisna<-array(as.numeric(!is.na(dat)),dim=dim(dat)); #needed to get TRUE/FALSE converted to 1/0 in an array
  n.neighbours<-array(0,dim=dim(dat))
  allnisna<-array(0,dim=dim(dat))
  if(length(dim(dat))==3){
  for(d in 1:length(dim(dat))){
    if(d==1){
      datr<-dat[c(2:dim(dat)[1],dim(dat)[1]),,] #values to the right
      datl<-dat[c(1,1:(dim(dat)[1]-1)),,] #values to the left
      if(diagTF){
        datru<-datr[,c(2:dim(dat)[2],dim(dat)[2]),] #values to the right and up
        datld<-datl[,c(1,1:(dim(dat)[2]-1)),] #values to the left and down
      }
    } else if(d==2){
      datr<-dat[,c(2:dim(dat)[2],dim(dat)[2]),]; #values to the right
      datl<-dat[,c(1,1:(dim(dat)[2]-1)),] #values to the left
      if(diagTF){
        datru<-datr[c(1,1:(dim(dat)[1]-1)),,] #values to the right and up
        datld<-datl[c(1,1:(dim(dat)[1]-1)),,] #values to the left and down
      }
    } else {
      datr<-dat[,,c(2:dim(dat)[3],dim(dat)[3])] #values to the right
      datl<-dat[,,c(1,1:(dim(dat)[3]-1))] #values to the left
    }
    nisnar<-array(as.numeric(!is.na(datr)),dim=dim(dat)); #needed to get TRUE/FALSE converted to 1/0 in an array
    nisnal<-array(as.numeric(!is.na(datl)),dim=dim(dat));
    datr[is.na(datr)]<-0
    datl[is.na(datl)]<-0
    n.neighbours<-n.neighbours+datr*nisnar+datl*nisnal
    allnisna<-allnisna+nisnar+nisnal
    if(d!=3&diagTF){  #diagonal neighbours
      nisnaru<-array(as.numeric(!is.na(datru)),dim=dim(dat)); #needed to get TRUE/FALSE converted to 1/0 in an array
      nisnald<-array(as.numeric(!is.na(datld)),dim=dim(dat));
      datru[is.na(datru)]<-0
      datld[is.na(datld)]<-0
      n.neighbours<-n.neighbours+datru*nisnaru+datld*nisnald
      allnisna<-allnisna+nisnaru+nisnald
    }
  }
  n.neighbours<-n.neighbours/allnisna
  datn<-dat;datn[is.na(dat)]<-0
  dat4<-datn*nisna+ (1-nisna)*n.neighbours
  dat4[allnisna==0]<-NA
  return(dat4)
  } else if(length(dim(dat))==2){
   for(d in 1:length(dim(dat))){
    if(d==1){
      datr<-dat[c(2:dim(dat)[1],dim(dat)[1]),] #values to the right
      datl<-dat[c(1,1:(dim(dat)[1]-1)),] #values to the left
      if(diagTF){
        datru<-datr[,c(2:dim(dat)[2],dim(dat)[2])] #values to the right and up
        datld<-datl[,c(1,1:(dim(dat)[2]-1))] #values to the left and down
      }
    } else {
      datr<-dat[,c(2:dim(dat)[2],dim(dat)[2])]; #values to the right
      datl<-dat[,c(1,1:(dim(dat)[2]-1))] #values to the left
      if(diagTF){
        datru<-datr[c(1,1:(dim(dat)[1]-1)),] #values to the right and up
        datld<-datl[c(1,1:(dim(dat)[1]-1)),] #values to the left and down
      }
    }
    nisnar<-array(as.numeric(!is.na(datr)),dim=dim(dat)); #needed to get TRUE/FALSE converted to 1/0 in an array
    nisnal<-array(as.numeric(!is.na(datl)),dim=dim(dat));
    datr[is.na(datr)]<-0
    datl[is.na(datl)]<-0
    n.neighbours<-n.neighbours+datr*nisnar+datl*nisnal
    allnisna<-allnisna+nisnar+nisnal
    if(d!=3&diagTF){  #diagonal neighbours
      nisnaru<-array(as.numeric(!is.na(datru)),dim=dim(dat)); #needed to get TRUE/FALSE converted to 1/0 in an array
      nisnald<-array(as.numeric(!is.na(datld)),dim=dim(dat));
      datru[is.na(datru)]<-0
      datld[is.na(datld)]<-0
      n.neighbours<-n.neighbours+datru*nisnaru+datld*nisnald
      allnisna<-allnisna+nisnaru+nisnald
    }
  }
  n.neighbours<-n.neighbours/allnisna
  datn<-dat;datn[is.na(dat)]<-0
  dat4<-datn*nisna+ (1-nisna)*n.neighbours
  dat4[allnisna==0]<-NA
  return(dat4)
 }
}
