/*
Functions gets matrix containing a mapping from input matrix indices
to output matrix indices. Values are copied from input matrix and
summed up in output matrix accordingly.
Input matrix must have no NA but only 0 for no fluxes!


serialization rule:
- transpose (only) INPUT matrices! 
- rebuild matrix in R using: matrix(result_vector, nrow=ROWS, ncol=COLS, byrow=T)

index formular: i*COLS+j

array assignment expression:
output_array = *(input_array+(i*COLS+j));

R definition:
dyn.load("apply_mapping.so")
apply.mapping <- function(mapping, inmat, outmat)
  .C("apply_mapping",
      as.integer(mapping),
      as.integer(dim(mapping)[2]),
      as.integer(dim(mapping)[1]),
      as.double(inmat),
      as.integer(dim(inmat)[1]),
      as.integer(dim(outmat)[2]),
      outmat = double(length(outmat)))$outmat

*/


#include <R.h>
#include <stdio.h>


void apply_mapping_synmap(int    *mapping,
                          int    *mrows,          
       	 	          int    *mcols, 
		          double *inmat, 
		          int    *incols, 
		          int    *outcols,
			  int    *vegclass, 
		          double *outmat) {


 int i;
 int i_out, i_in, ind;
 int sum;

 printf("vegclass: %d mrows: %d mcols: %d incols: %d outcols: %d\n", *vegclass, *mrows, *mcols, *incols, *outcols);

 for (i=0;i<*mrows;i++) {  
  ind   = i**mcols;
  i_out = (*(mapping+ind+2)-1)**outcols+*(mapping+ind+3);
  i_in  = (*(mapping+ind)-1)**incols+*(mapping+ind+1);
  
  //printf("in_i: %d in_j: %d out_i: %d out_j: %d i_in: %d i_out: %d sum: %d\n",(*(mapping+ind)-1), *(mapping+ind+1),  (*(mapping+ind+2)-1), *(mapping+ind+3), i_in, i_out, *(mapping+ind+4));
  
  // only sum up values 
  if (*(inmat+i_in)==*vegclass) {
   outmat[i_out] = *(outmat+i_out) + *(inmat+i_in);
  }
 }
 
}
